-- 古镇秘藏 建筑激活Window
Lua_TownTreasureBuildActiveWindow = class("Lua_TownTreasureBuildActiveWindow", Lua_Window);

function Lua_TownTreasureBuildActiveWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_TownTreasureBuildActiveWindow";
	self.skinName = "TownTreasureBuildActiveWindow_skin";
end

function Lua_TownTreasureBuildActiveWindow:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.townTreasureData.isOpenAuto then
		self:addTimer("closeWindow", 1, self, self.hide);
	end
end

function Lua_TownTreasureBuildActiveWindow:showWin(param)
	self:superCall("showWin", param);

	self.buildImg:setScale(1, 1, 1);
	self.buildImg:SetDimensions(0, 0);
	self.buildImg:setUrl(nil);
	self.buildImg:setUrl(param.imgUrl);

	local config;
	if DataCenter.townTreasureData.buildNum > 0 then
		DataCenter.townTreasureData.buildNum = DataCenter.townTreasureData.buildNum - 1;
		config = DataCenter.townTreasureUtil:buildCfg(param.id + 2);
	end
	if config == nil then
		config = DataCenter.townTreasureUtil:buildCfg(param.id + 1);
	end

	self.nameTxt.text = config.building_name;
	self.lvlTxt.text = LanUtil.formateStr(710036, config.level);

	self.nameTxt:resetSize();
	local offsetX = (self.nameTxt.width - 136) / 2;
	self.nameTxt:setLocation(31 + offsetX, -114, 0);
	self.lvlTxt:setLocation(40 + offsetX, -117, 0);

	local output = config[DataCenter.townTreasureData.keyWord];
	local tvo = Lua_ToolVo.createToolVo(config.create);
	local iconWidth = tvo.iconWidth > 0 and tvo.iconWidth or 35;
	local iconHeight = tvo.iconHeight > 0 and tvo.iconHeight or 35;
	self.outputTxt.text = LanUtil.formateStr(710038, spliceIconStr(tvo.iconAtlas, tvo.iconSprite, iconWidth, iconHeight), output[3], output[2]);
end

function Lua_TownTreasureBuildActiveWindow:dispose()
	if self.showData ~= nil and self.showData.owner ~= nil and self.showData.callFun ~= nil then
		self.showData.callFun(self.showData.owner);
	end
	self:superCall("dispose");
end
