-- 古镇秘藏 建筑升级Window
Lua_TownTreasureBuildUpWindow = class("Lua_TownTreasureBuildUpWindow", Lua_Window);

function Lua_TownTreasureBuildUpWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_TownTreasureBuildUpWindow";
	self.skinName = "TownTreasureBuildUpWindow_skin";
end

function Lua_TownTreasureBuildUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.townTreasureData.isOpenAuto then
		self:addTimer("closeWindow", 1, self, self.hide);
	end
end

function Lua_TownTreasureBuildUpWindow:showWin(param)
	self:superCall("showWin", param);

	-- self.leftBuildImg:setScale(1, 1, 1);
	self.leftBuildImg:SetDimensions(0, 0);
	self.leftBuildImg:setUrl(nil);
	self.leftBuildImg:setUrl(param.imgUrl);

	-- self.rightBuildImg:setScale(1, 1, 1);
	self.rightBuildImg:SetDimensions(0, 0);
	self.rightBuildImg:setUrl(nil);
	self.rightBuildImg:setUrl(param.imgUrl);

	local config = DataCenter.townTreasureUtil:buildCfg(param.id);
	local output = config[DataCenter.townTreasureData.keyWord];
	local tvo = Lua_ToolVo.createToolVo(config.create);
	local iconWidth = tvo.iconWidth > 0 and tvo.iconWidth or 35;
	local iconHeight = tvo.iconHeight > 0 and tvo.iconHeight or 35;
	self.leftNameTxt.text = config.building_name;
	self.leftLvlTxt.text = LanUtil.formateStr(710036, config.level);
	self.leftItemTxt.text = LanUtil.formateStr(710037, spliceIconStr(tvo.iconAtlas, tvo.iconSprite, iconWidth, iconHeight), output[3], output[2]);

	self.leftNameTxt:resetSize();
	local offsetX = (self.leftNameTxt.width - 111) / 2;
	self.leftNameTxt:setLocation(-140 + offsetX, 106, 0);
	self.leftLvlTxt:setLocation(-131.6 + offsetX, 103, 0);

	if DataCenter.townTreasureData.buildNum > 0 then
		DataCenter.townTreasureData.buildNum = DataCenter.townTreasureData.buildNum - 1;
		config = DataCenter.townTreasureUtil:buildCfg(param.id + 2);
		if config == nil then
			config = DataCenter.townTreasureUtil:buildCfg(param.id + 1);
		end
	else
		config = DataCenter.townTreasureUtil:buildCfg(param.id + 1);
	end
	output = config[DataCenter.townTreasureData.keyWord];
	self.rightNameTxt.text = config.building_name;
	self.rightLvlTxt.text = LanUtil.formateStr(710036, config.level);
	self.rightItemTxt.text = LanUtil.formateStr(710037, spliceIconStr(tvo.iconAtlas, tvo.iconSprite, iconWidth, iconHeight), output[3], output[2]);

	self.rightNameTxt:resetSize();
	local offsetX = (self.rightNameTxt.width - 111) / 2;
	self.rightNameTxt:setLocation(191 + offsetX, 106, 0);
	self.rightLvlTxt:setLocation(199 + offsetX, 103, 0);
end

function Lua_TownTreasureBuildUpWindow:dispose()
	if self.showData ~= nil and self.showData.owner ~= nil and self.showData.callFun ~= nil then
		self.showData.callFun(self.showData.owner);
	end
	self:superCall("dispose");
end
