-- 古镇秘藏 格子Item
Lua_TownTreasureCellItem = class("Lua_TownTreasureCellItem", Lua_DisplayObject);

function Lua_TownTreasureCellItem:ctor(p, tweenObj)
    self.tweenObj = tweenObj;
    self:superCall("ctor", p, "TownTreasureCellItem_skin");
end

function Lua_TownTreasureCellItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_TownTreasureCellItem:dispose()
    if self.buildImg ~= nil then
        self.buildImg:dispose();
        self.buildImg = nil;
    end
    if self.showIcon ~= nil then
        TweenUtil.getInstance():stop(self.showIcon.mainContent);
        self.showIcon:dispose();
        self.showIcon = nil;
    end
    if self.shadowIcon ~= nil then
        self.shadowIcon:dispose();
        self.shadowIcon = nil;
    end
    if self.showEff ~= nil then
        self.showEff:dispose();
        self.showEff = nil;
    end
    if self.levelUpEff ~= nil then
        self.levelUpEff:dispose();
        self.levelUpEff = nil;
    end
    self.tweenObj = nil;
	self:superCall("dispose");
end

function Lua_TownTreasureCellItem:setData(data) 
    self.data = data;
    self:updateData();
end

function Lua_TownTreasureCellItem:updateData()
    if self.isFirstIn == nil then
        self.isFirstIn = false;
        self.content.name = self.data.id;
        if self.data.icon_res ~= nil then
            self.bg:setAltas(self.data.icon_res[1], self.data.icon_res[2]);
            self.bg:SetDimensions(self.data.cellWidth, self.data.cellHight);
        else
            self.bg:setEnable(false);
        end
        self:setLocation(self.data.posX , -self.data.posY);
        self:setRectAnchor(0);

        self.showObj:SetActive(self.data.is_building);
        self.rewardObj:SetActive(self.data.is_building);
    end

    if self.data.is_building then
        if self.buildImg == nil then
            local pos = self.data.build_offset_pos;
            self.buildImg = UICreate.createImage(self.content, self.data.img_path, pos[1], pos[2], 0, 0);
            self.buildImg.siblingIndex = 1;

            pos = self.data.name_offset_pos;
            LuaUtil.setObjPos(self.showObj, pos[1], pos[2], 0);
            pos = self.data.icon_offset_pos;
            LuaUtil.setObjPos(self.rewardObj, pos[1], pos[2], 0);
        end

        self.nameTxt.text = self.data.building_name;
        self.lvlTxt.text = self.data.level;
        self.rewardTxt.text = self.data.value;
        local vo = Lua_ToolVo.createToolVo(self.data.itemId);
        self.rewardIcon:setAltas(vo.atlas, vo.sprite);
        self.rewardObj:SetActive(self.data.value > 0); 
    elseif self.data.eventId ~= nil and self.data.eventId ~= 0 then
        if self.shadowIcon == nil then
            self.shadowIcon = UICreate.createUIAtlasImage(self.content, "townTreasure_atlas", "xui_gcmz_window_24", 0, 0, 0, 0);
        end
        if self.showIcon == nil then
            self.showIcon = UICreate.createUIAtlasImage(self.content, "", "", 0, 35, 0, 0);
            self.showIcon.name = "showIcon_" .. self.data.id;
        end
        if self.showEff == nil then
            self.showEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_gcmb_jiangli_01", "ui_gcmb_jiangli_01", 0, 0);
        end
        if self.data.reward_type == 3 then
            self.showIcon:setAltas(self.data.addIcon[1], self.data.addIcon[2]);
        else
            self.itemVo = Lua_ToolVo.createToolVo(self.data.itemId, self.data.value);
            self.showIcon:setAltas(self.itemVo.atlas, self.itemVo.sprite);
        end
        self.showIcon:SetDimensions(self.data.icon_size[1], self.data.icon_size[2]);
        self.showIcon:setEnable(true);
        self.shadowIcon:setEnable(true);
        self.showEff:setEnable(true);
        self:setSlowTween(true);
    else
        if self.showIcon ~= nil then
            self.showIcon:setEnable(false);
            self:setSlowTween(false);
        end
        if self.shadowIcon ~= nil then
            self.shadowIcon:setEnable(false);
        end
        if self.showEff ~= nil then
            self.showEff:setEnable(false);
        end
    end

    if self.isItemFly then
        self.isItemFly = false;
        if self.showIcon ~= nil then
            TweenUtil.getInstance():stop(self.showIcon.mainContent);
            self.showIcon:setScale(1, 1, 1);
        end
    end
end

function Lua_TownTreasureCellItem:checkInBound(touchX, touchY)
    if self.data.is_building == false then
        return false;
    end

    local posX = self.posX + self.data.build_offset_pos[1];
    local posY = self.posY + self.data.build_offset_pos[2];
    local width = self.buildImg.width / 2;
    local height = self.buildImg.height / 2;
    local minX = posX - width;
    local maxX = posX + width;
    local minY = posY - height;
    local maxY = posY + height;
    if touchX >= minX and touchX <= maxX and touchY >= minY and touchY <= maxY then
        return true;
    end
    return false;
end

function Lua_TownTreasureCellItem:onCellClick()
    if DataCenter.townTreasureData.isMoving or DataCenter.townTreasureData.isTheWorld then
        OperateAlert.showLangValue(710008);
        return;
    end
    if self.data.level == 0 then
        OperateAlert.show(LanUtil.formateStr(710017, self.data.building_name));
    else
        Lua_WindowUtil.openWin("Lua_TownTreasureBuildWindow", Lua_WinParam.ACTION_OPEN, self.data);
    end 
end

function Lua_TownTreasureCellItem:setSlowTween(val)
    if self.isSetSlow == val then return end
    self.isSetSlow = val;

    if val then
        self.showIcon:setParent(self.tweenObj);
        self.showIcon:setLocation(self.data.posX, -self.data.posY + 35, 0);
    else
        self.showIcon:setParent(self.content);
        self.showIcon:setLocation(0, 35, 0);
    end
end

function Lua_TownTreasureCellItem:onShowTip()
    if self.data.is_building then
        -- 记录数据
        self.addCfg = self.data.addCfg;
        self.addCfgId = self.data.addCfgId;
        self.isMaxLevel = self.data.level >= self.data.max_level;

        if self.data.level ~= 0 and self.data.value ~= 0 then
            local arr = Array();
            arr:add(Lua_ToolVo.createToolVo(self.data.itemId, self.data.value));

            self.isPlayBuildEff = false;
            local param = {data = arr, owner = self, cancelFun = self.onPlayBuildEff};
            Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, param);

            if DataCenter.townTreasureData.isOpenAuto then
                self:addTimer("closeTipWindow", 1, self, self.closeTipWindow);
            end
        else
            self:onPlayBuildEff();
        end
    elseif self.data.eventId ~= nil and self.data.eventId ~= 0 then
        if self.data.reward_type == 3 then -- buff获得
            if self.data.eventId == 3008 then -- 奔跑buff
                Lua_MsgUtil.callFunc("TOWN_TREASURE_PLAY_RUN", true);
            elseif self.data.eventId == 3009 then -- 传送buff
                Lua_MsgUtil.callFunc("TOWN_TREASURE_PLAY_TRANSFER", true);
            elseif self.data.eventId == 3010 then -- 磁铁buff
                Lua_MsgUtil.callFunc("TOWN_TREASURE_ITEM_FLY");
                self.showRewardArr = DataCenter.townTreasureData.magnetRewardArr;
                self:addTimer("delayRefreshItem", 3, self, self.delayRefreshItem);
            end

            local str = self.data.describe;
            if self.data.eventId == 3001 or self.data.eventId == 3002 or self.data.eventId == 3008 then -- 移动步数
                str = LanUtil.formateStr(str, DataCenter.townTreasureData.diceInfoArr[1].dice);
            elseif self.data.eventId == 3004 then -- 增加骰子次数
                local num = DataCenter.townTreasureData.saveDiceTime - DataCenter.townTreasureData.diceTime;
                str = LanUtil.formateStr(str, num);
            end
            local data = {posX = self.data.posX, posY = -self.data.posY, curType = 1, desc = str}
            Lua_MsgUtil.callFunc("TOWN_TREASURE_ADD_ITEM_TIP", data);

            if self.data.delay_time ~= nil then -- 触发buff原地停留时间
                Lua_MsgUtil.callFunc("TOWN_TREASURE_PLAY_DELAY", self.data.delay_time);
            end
        else
            if DataCenter.townTreasureData.doubleNum > 0 then
                self.itemVo.count = self.itemVo.count * 2;
                DataCenter.townTreasureData.doubleNum = DataCenter.townTreasureData.doubleNum - 1;
            end
            local data = {posX = self.data.posX, posY = -self.data.posY, curType = 2, itemVo = self.itemVo}
            Lua_MsgUtil.callFunc("TOWN_TREASURE_ADD_ITEM_TIP", data);
            Lua_MsgUtil.callFunc("TOWN_TREASURE_GET_EFFECT_PLAY");
        end
    end
end

function Lua_TownTreasureCellItem:onPlayBuildEff()
    if self.data == nil then return end
    
    self.isPlayBuildEff = true;
    if not self.isMaxLevel then
        local dic = {id = self.addCfgId, imgUrl = self.data.img_path, owner = self, callFun = self.onLevelUp};
        if self.addCfg.level == 0 then
            Lua_WindowUtil.openWin("Lua_TownTreasureBuildActiveWindow", Lua_WinParam.ACTION_OPEN, dic);
        else
            Lua_WindowUtil.openWin("Lua_TownTreasureBuildUpWindow", Lua_WinParam.ACTION_OPEN, dic);
        end
    end
end

function Lua_TownTreasureCellItem:onLevelUp()
    if self.data == nil then return end

    if self.levelUpEff == nil then
        self.levelUpEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_gcmb_jianzhushengji_01", "ui_gcmb_jianzhushengji_01", self.data.name_offset_pos[1], self.data.name_offset_pos[2]);
    else
        self.levelUpEff:setEnable(false);
        self.levelUpEff:setEnable(true);
    end
end

function Lua_TownTreasureCellItem:closeTipWindow()
    self:removeTimer(self, self.closeTipWindow);
    Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_CLOSE);
    if not self.isPlayBuildEff then
        self:onPlayBuildEff();
    end
end

function Lua_TownTreasureCellItem:delayRefreshItem()
    self:removeTimer(self, self.delayRefreshItem);
    Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, self.showRewardArr);

    if DataCenter.townTreasureData.isTheWorld then
        DataCenter.townTreasureData.isTheWorld = false;
        Lua_ProxyManager.getProxy("Lua_TownTreasureProxy"):sActivityInfo();
        Lua_MsgUtil.callFunc("TOWN_TREASURE_PLAY_END");
    end
end

function Lua_TownTreasureCellItem:onItemFly(posX, posY, delayTime)
    self.isItemFly = true;
    self:setSlowTween(false);
    if self.showIcon ~= nil then
        TweenUtil.getInstance():addTween(self.showIcon.mainContent, 1, delayTime,
            posX - self.data.posX, posY + self.data.posY + 35, 0,
            0, 0, 0,
            1, 1, 1);
    end
    if self.shadowIcon ~= nil then
        self.shadowIcon:setEnable(false);
    end
    if self.showEff ~= nil then
        self.showEff:setEnable(false);
    end
end