-- 古镇秘藏 建筑总览window
Lua_TownTreasureViewWindow = class("Lua_TownTreasureViewWindow", Lua_Window);

function Lua_TownTreasureViewWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_TownTreasureViewWindow";
	self.skinName = "TownTreasureViewWindow_skin";
end

function Lua_TownTreasureViewWindow:buildPanel(go)
	self:superCall("buildPanel", go);
end

function Lua_TownTreasureViewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 627, 780, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_TownTreasureViewItem, 627, 174, 1);
	self.dragList:setLocation(-3, -41, 0);

	local buildArr = DataCenter.townTreasureData.getBuildCellArr;
	local arr = Array();
	arr:add({isLoop = true})
	for i = 1, buildArr:getSize() do
		arr:add(buildArr[i]);
	end
	self.dragList:setArrayData(arr);
end

function Lua_TownTreasureViewWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end



















Lua_TownTreasureViewItem = class("Lua_TownTreasureViewItem", Lua_ListCell);

function Lua_TownTreasureViewItem:ctor(p)
    self:superCall("ctor", p, "TownTreasureViewItem_skin");
end

function Lua_TownTreasureViewItem:buildShowItem()
    self:superCall("buildShowItem");

    self.buildImg:addClickFuntion(self, self.onBgClick);
end

function Lua_TownTreasureViewItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_TownTreasureViewItem:setData(data)
	self.data = data;

	if data.isLoop ~= nil then
		local townTreasureUtil = DataCenter.townTreasureUtil;
		local icon = townTreasureUtil:getConstConfig("round_map_icon", 3);
		self.showIcon:setAltas(icon[1], icon[2]);
		self.titleTxt:setLangValue(710023);

		local level = DataCenter.townTreasureUtil:getLoopRewardLv(DataCenter.townTreasureData.curVersion, DataCenter.townTreasureData.loopTime);
		self.tipTxt.text = LanUtil.formateStr(710024, level, DataCenter.townTreasureData.loopTime);

		local rewardList = DataCenter.townTreasureData:getLoopRewardConfig(DataCenter.townTreasureData.loopTime + 1);
		local str = "";
		for i = 1, #rewardList do
			str = str ..  LanUtil.formateStr(710025, spliceIconStrById(rewardList[i][1]), rewardList[i][2]);
		end
		self.showTxt.text = str;
	else
		-- self.showIcon:setAltas(data.addIcon[1], data.addIcon[2]);
		self.buildImg.resetBgSize = true;
		self.buildImg:setUrl(data.img_path);
		self.buildImg:setScale(0.5, 0.5);
		self.titleTxt.text = data.building_name;
		self.nameTxt.text = LanUtil.formateStr(710026, data.building_name, data.level, data.max_level);
		self.outputTxt.text = LanUtil.formateStr(710027, data.output, data.output_time);
		local itemVo = Lua_ToolVo.createToolVo(data.itemId);
		self.itemIcon:setAltas(itemVo.atlas, itemVo.sprite);
		self.rewardTxt.text = LanUtil.formateStr(710028, data.output_time - data.curTime, itemVo.name, data.output);
		self.curBar:setMaxValue(data.limit);
		self.curBar:setValue(data.value);
		self.curBar:setText(data.value .. "/" .. data.limit);
	end

	local isShow = data.isLoop == nil;
	self.tipTxt:setEnable(not isShow);
	self.showTxt:setEnable(not isShow);
	self.showIcon:setEnable(not isShow);
	self.showIcon.mouseEnable = isShow;
	self.itemIcon:setEnable(isShow);
	self.curBar:setEnable(isShow);
	self.nameTxt:setEnable(isShow);
	self.outputTxt:setEnable(isShow);
	self.rewardTxt:setEnable(isShow);
	self.itemBg:setEnable(isShow);
	self.buildImg:setEnable(isShow);
end

function Lua_TownTreasureViewItem:onBgClick()
	Lua_MsgUtil.callFunc("TOWN_TREASURE_MAP_MOVE", self.data.id);
	Lua_WindowUtil.openWin("Lua_TownTreasureViewWindow", Lua_WinParam.ACTION_CLOSE);
end